(* rec_funcs.ml: used for demonstration of activation records for
   recursive functions *)

(* Recursive factorial definition; will create a linear growth of the
   function call stack *)
let rec fact n =
  if n=1 || n=0 then
    1
  else
    let fm1 = fact (n-1) in
    n*fm1
;;

(* Recursive fibonnacci number implementation

   Fibonacci numbers are defined by the recurrence
   fib(0) = 0
   fib(1) = 1
   fib(n) = fib(n-1) + fib(n-2)

   The branching of this version leads to significant computational
   complexity.
 *)

let rec fib n =
  if n=0 then
    0
  else if n=1 then
    1
  else
    let fn1 = fib (n-1) in
    let fn2 = fib (n-2) in
    fn1+fn2
;;
